<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.9.0"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>API: exampleMocoInverse.cpp</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script>
<script type="text/javascript" async="async" src="MathJax-2.7.0/MathJax.js"></script>
<link href="doxygen_developer.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="OpenSimLogoWhiteHorizontal_small.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">API
   &#160;<span id="projectnumber">4.4.1-2022-09-05-d4bb9bc34</span>
   </div>
   <div id="projectbrief">For C++ developers</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.0 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search','.html');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(document).ready(function(){initNavTree('exampleMocoInverse_8cpp-example.html',''); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">exampleMocoInverse.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<p>This is an example using the MocoInverse tool with a complex model to prescribe walking. This example also shows how to track electromyography data.</p>
<div class="fragment"><div class="line"><span class="comment">/* -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * OpenSim Moco: exampleMocoInverse.cpp                                       *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- *</span></div>
<div class="line"><span class="comment"> * Copyright (c) 2020 Stanford University and the Authors                     *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Author(s): Christopher Dembia                                              *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may    *</span></div>
<div class="line"><span class="comment"> * not use this file except in compliance with the License. You may obtain a  *</span></div>
<div class="line"><span class="comment"> * copy of the License at http://www.apache.org/licenses/LICENSE-2.0          *</span></div>
<div class="line"><span class="comment"> *                                                                            *</span></div>
<div class="line"><span class="comment"> * Unless required by applicable law or agreed to in writing, software        *</span></div>
<div class="line"><span class="comment"> * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,          *</span></div>
<div class="line"><span class="comment"> * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.   *</span></div>
<div class="line"><span class="comment"> * See the License for the specific language governing permissions and        *</span></div>
<div class="line"><span class="comment"> * limitations under the License.                                             *</span></div>
<div class="line"><span class="comment"> * -------------------------------------------------------------------------- */</span></div>
<div class="line"> </div>
<div class="line"> </div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Actuators/ModelOperators.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Common/Adapters.h&gt;</span></div>
<div class="line"><span class="preprocessor">#include &lt;OpenSim/Moco/osimMoco.h&gt;</span></div>
<div class="line"> </div>
<div class="line"><span class="keyword">using namespace </span><a class="code" href="namespaceOpenSim.html">OpenSim</a>;</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">void</span> solveMocoInverse() {</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Construct the MocoInverse tool.</span></div>
<div class="line">    MocoInverse inverse;</div>
<div class="line">    inverse.setName(<span class="stringliteral">&quot;example3DWalking_MocoInverse&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Construct a ModelProcessor and set it on the tool. The default</span></div>
<div class="line">    <span class="comment">// muscles in the model are replaced with optimization-friendly</span></div>
<div class="line">    <span class="comment">// DeGrooteFregly2016Muscles, and adjustments are made to the default muscle</span></div>
<div class="line">    <span class="comment">// parameters.</span></div>
<div class="line">    ModelProcessor modelProcessor(<span class="stringliteral">&quot;subject_walk_armless.osim&quot;</span>);</div>
<div class="line">    modelProcessor.append(ModOpAddExternalLoads(<span class="stringliteral">&quot;grf_walk.xml&quot;</span>));</div>
<div class="line">    modelProcessor.append(ModOpIgnoreTendonCompliance());</div>
<div class="line">    modelProcessor.append(ModOpReplaceMusclesWithDeGrooteFregly2016());</div>
<div class="line">    <span class="comment">// Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line">    modelProcessor.append(ModOpIgnorePassiveFiberForcesDGF());</div>
<div class="line">    <span class="comment">// Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line">    modelProcessor.append(ModOpScaleActiveFiberForceCurveWidthDGF(1.5));</div>
<div class="line">    modelProcessor.append(ModOpAddReserves(1.0));</div>
<div class="line">    inverse.setModel(modelProcessor);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Construct a TableProcessor of the coordinate data and pass it to the</span></div>
<div class="line">    <span class="comment">// inverse tool. TableProcessors can be used in the same way as</span></div>
<div class="line">    <span class="comment">// ModelProcessors by appending TableOperators to modify the base table.</span></div>
<div class="line">    <span class="comment">// A TableProcessor with no operators, as we have here, simply returns the</span></div>
<div class="line">    <span class="comment">// base table.</span></div>
<div class="line">    inverse.setKinematics(TableProcessor(<span class="stringliteral">&quot;coordinates.sto&quot;</span>));</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Initial time, final time, and mesh interval.</span></div>
<div class="line">    inverse.set_initial_time(0.81);</div>
<div class="line">    inverse.set_final_time(1.79);</div>
<div class="line">    inverse.set_mesh_interval(0.02);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// By default, Moco gives an error if the kinematics contains extra columns.</span></div>
<div class="line">    <span class="comment">// Here, we tell Moco to allow (and ignore) those extra columns.</span></div>
<div class="line">    inverse.set_kinematics_allow_extra_columns(<span class="keyword">true</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Solve the problem and write the solution to a Storage file.</span></div>
<div class="line">    MocoInverseSolution solution = inverse.solve();</div>
<div class="line">    solution.getMocoSolution().write(</div>
<div class="line">            <span class="stringliteral">&quot;example3DWalking_MocoInverse_solution.sto&quot;</span>);</div>
<div class="line"> </div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">void</span> solveMocoInverseWithEMG() {</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// This initial block of code is identical to the code above.</span></div>
<div class="line">    MocoInverse inverse;</div>
<div class="line">    inverse.setName(<span class="stringliteral">&quot;example3DWalking_MocoInverseWithEMG&quot;</span>);</div>
<div class="line">    ModelProcessor modelProcessor(<span class="stringliteral">&quot;subject_walk_armless.osim&quot;</span>);</div>
<div class="line">    modelProcessor.append(ModOpAddExternalLoads(<span class="stringliteral">&quot;grf_walk.xml&quot;</span>));</div>
<div class="line">    modelProcessor.append(ModOpIgnoreTendonCompliance());</div>
<div class="line">    modelProcessor.append(ModOpReplaceMusclesWithDeGrooteFregly2016());</div>
<div class="line">    <span class="comment">// Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line">    modelProcessor.append(ModOpIgnorePassiveFiberForcesDGF());</div>
<div class="line">    <span class="comment">// Only valid for DeGrooteFregly2016Muscles.</span></div>
<div class="line">    modelProcessor.append(ModOpScaleActiveFiberForceCurveWidthDGF(1.5));</div>
<div class="line">    modelProcessor.append(ModOpAddReserves(1.0));</div>
<div class="line">    inverse.setModel(modelProcessor);</div>
<div class="line">    inverse.setKinematics(TableProcessor(<span class="stringliteral">&quot;coordinates.sto&quot;</span>));</div>
<div class="line">    inverse.set_initial_time(0.81);</div>
<div class="line">    inverse.set_final_time(1.79);</div>
<div class="line">    inverse.set_mesh_interval(0.02);</div>
<div class="line">    inverse.set_kinematics_allow_extra_columns(<span class="keyword">true</span>);</div>
<div class="line"> </div>
<div class="line">    MocoStudy study = inverse.initialize();</div>
<div class="line">    MocoProblem&amp; problem = study.updProblem();</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Add electromyography tracking.</span></div>
<div class="line">    <span class="keyword">auto</span>* tracking = problem.addGoal&lt;MocoControlTrackingGoal&gt;(<span class="stringliteral">&quot;emg_tracking&quot;</span>);</div>
<div class="line">    tracking-&gt;setWeight(50.0);</div>
<div class="line">    <span class="comment">// Each column in electromyography.sto is normalized so the maximum value in</span></div>
<div class="line">    <span class="comment">// each column is 1.0.</span></div>
<div class="line">    <a name="a0"></a><a class="code" href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">TimeSeriesTable</a> controlsRef(<span class="stringliteral">&quot;electromyography.sto&quot;</span>);</div>
<div class="line">    <span class="comment">// Scale the tracked muscle activity based on peak levels from</span></div>
<div class="line">    <span class="comment">// &quot;Gait Analysis: Normal and Pathological Function&quot; by</span></div>
<div class="line">    <span class="comment">// Perry and Burnfield, 2010 (digitized by Carmichael Ong).</span></div>
<div class="line">    controlsRef.updDependentColumn(<span class="stringliteral">&quot;soleus&quot;</span>) *= 0.77;</div>
<div class="line">    controlsRef.updDependentColumn(<span class="stringliteral">&quot;gastrocnemius&quot;</span>) *= 0.87;</div>
<div class="line">    controlsRef.updDependentColumn(<span class="stringliteral">&quot;tibialis_anterior&quot;</span>) *= 0.37;</div>
<div class="line">    tracking-&gt;setReference(controlsRef);</div>
<div class="line">    <span class="comment">// Associate actuators in the model with columns in electromyography.sto.</span></div>
<div class="line">    tracking-&gt;setReferenceLabel(<span class="stringliteral">&quot;/forceset/soleus_r&quot;</span>, <span class="stringliteral">&quot;soleus&quot;</span>);</div>
<div class="line">    tracking-&gt;setReferenceLabel(<span class="stringliteral">&quot;/forceset/gasmed_r&quot;</span>, <span class="stringliteral">&quot;gastrocnemius&quot;</span>);</div>
<div class="line">    tracking-&gt;setReferenceLabel(<span class="stringliteral">&quot;/forceset/gaslat_r&quot;</span>, <span class="stringliteral">&quot;gastrocnemius&quot;</span>);</div>
<div class="line">    tracking-&gt;setReferenceLabel(<span class="stringliteral">&quot;/forceset/tibant_r&quot;</span>, <span class="stringliteral">&quot;tibialis_anterior&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Solve the problem and write the solution to a Storage file.</span></div>
<div class="line">    MocoSolution solution = study.solve();</div>
<div class="line">    solution.write(<span class="stringliteral">&quot;example3DWalking_MocoInverseWithEMG_solution.sto&quot;</span>);</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// Write the reference data in a way that&#39;s easy to compare to the solution.</span></div>
<div class="line">    controlsRef.removeColumn(<span class="stringliteral">&quot;medial_hamstrings&quot;</span>);</div>
<div class="line">    controlsRef.removeColumn(<span class="stringliteral">&quot;biceps_femoris&quot;</span>);</div>
<div class="line">    controlsRef.removeColumn(<span class="stringliteral">&quot;vastus_lateralis&quot;</span>);</div>
<div class="line">    controlsRef.removeColumn(<span class="stringliteral">&quot;vastus_medius&quot;</span>);</div>
<div class="line">    controlsRef.removeColumn(<span class="stringliteral">&quot;rectus_femoris&quot;</span>);</div>
<div class="line">    controlsRef.removeColumn(<span class="stringliteral">&quot;gluteus_maximus&quot;</span>);</div>
<div class="line">    controlsRef.removeColumn(<span class="stringliteral">&quot;gluteus_medius&quot;</span>);</div>
<div class="line">    controlsRef.setColumnLabels({<span class="stringliteral">&quot;/forceset/soleus_r&quot;</span>, <span class="stringliteral">&quot;/forceset/gasmed_r&quot;</span>,</div>
<div class="line">                                 <span class="stringliteral">&quot;/forceset/tibant_r&quot;</span>});</div>
<div class="line">    controlsRef.appendColumn(<span class="stringliteral">&quot;/forceset/gaslat_r&quot;</span>,</div>
<div class="line">            controlsRef.getDependentColumn(<span class="stringliteral">&quot;/forceset/gasmed_r&quot;</span>));</div>
<div class="line">    <a name="a1"></a><a class="code" href="classOpenSim_1_1STOFileAdapter__.html#af40f174e371ab93d659a8223ed90458d">STOFileAdapter::write</a>(controlsRef, <span class="stringliteral">&quot;controls_reference.sto&quot;</span>);</div>
<div class="line">}</div>
<div class="line"> </div>
<div class="line"><span class="keywordtype">int</span> main() {</div>
<div class="line"> </div>
<div class="line">    solveMocoInverse();</div>
<div class="line"> </div>
<div class="line">    solveMocoInverseWithEMG();</div>
<div class="line"> </div>
<div class="line">    <span class="comment">// If you installed the Moco python package, you can compare both solutions</span></div>
<div class="line">    <span class="comment">// using the following command:</span></div>
<div class="line">    <span class="comment">//      opensim-moco-generate-report subject_walk_armless.osim</span></div>
<div class="line">    <span class="comment">//          example3DWalking_MocoInverse_solution.sto --bilateral</span></div>
<div class="line">    <span class="comment">//          --ref_files example3DWalking_MocoInverseWithEMG_solution.sto</span></div>
<div class="line">    <span class="comment">//                      controls_reference.sto</span></div>
<div class="line"> </div>
<div class="line">    <span class="keywordflow">return</span> EXIT_SUCCESS;</div>
<div class="line">}</div>
<div class="ttc" id="aclassOpenSim_1_1STOFileAdapter___html_af40f174e371ab93d659a8223ed90458d"><div class="ttname"><a href="classOpenSim_1_1STOFileAdapter__.html#af40f174e371ab93d659a8223ed90458d">OpenSim::STOFileAdapter_::write</a></div><div class="ttdeci">static void write(const TimeSeriesTable_&lt; T &gt; &amp;table, const std::string &amp;fileName)</div><div class="ttdoc">Write a STO file.</div><div class="ttdef"><b>Definition:</b> STOFileAdapter.h:139</div></div>
<div class="ttc" id="anamespaceOpenSim_html"><div class="ttname"><a href="namespaceOpenSim.html">OpenSim</a></div><div class="ttdoc">The Moco interface is contained within the OpenSim namespace.</div><div class="ttdef"><b>Definition:</b> ActivationCoordinateActuator.h:30</div></div>
<div class="ttc" id="anamespaceOpenSim_html_a39e2414750443cfa41c224f5cdd31bac"><div class="ttname"><a href="namespaceOpenSim.html#a39e2414750443cfa41c224f5cdd31bac">OpenSim::TimeSeriesTable</a></div><div class="ttdeci">TimeSeriesTable_&lt; SimTK::Real &gt; TimeSeriesTable</div><div class="ttdoc">See TimeSeriesTable_ for details on the interface.</div><div class="ttdef"><b>Definition:</b> TimeSeriesTable.h:519</div></div>
</div><!-- fragment --> </div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="footer">Generated on Mon Sep 5 2022 20:49:01 for API by <a href="https://www.doxygen.org/index.html"><img class="footer" src="doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.0 </li>
  </ul>
</div>
</body>
</html>
